<!DOCTYPE html>
<html lang="en">
	<head>
		<title>ProMED</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
		<link rel="apple-touch-icon" href="images/icon.png">
		<link rel="manifest" href="manifest.json">
		<link rel="shortcut icon" href="../files/favicon_white.ico" media="(prefers-color-scheme: dark)"/>
		<link rel="shortcut icon" href="../files/favicon.ico" media="(prefers-color-scheme: light)" />
	</head>
	<body>
		<link rel="stylesheet" href="css/main.css">

		<script src="https://unpkg.com/@ffmpeg/ffmpeg@0.9.6/dist/ffmpeg.min.js" defer></script>

		<script src="../examples/js/libs/draco/draco_encoder.js"></script>

		<link rel="stylesheet" href="js/libs/codemirror/codemirror.css">
		<link rel="stylesheet" href="js/libs/codemirror/theme/monokai.css">
		<script src="js/libs/codemirror/codemirror.js"></script>
		<script src="js/libs/codemirror/mode/javascript.js"></script>
		<script src="js/libs/codemirror/mode/glsl.js"></script>

		<script src="js/libs/esprima.js"></script>
		<script src="js/libs/jsonlint.js"></script>

		<link rel="stylesheet" href="js/libs/codemirror/addon/dialog.css">
		<link rel="stylesheet" href="js/libs/codemirror/addon/show-hint.css">
		<link rel="stylesheet" href="js/libs/codemirror/addon/tern.css">

		<script src="js/libs/codemirror/addon/dialog.js"></script>
		<script src="js/libs/codemirror/addon/show-hint.js"></script>
		<script src="js/libs/codemirror/addon/tern.js"></script>
		<script src="js/libs/acorn/acorn.js"></script>
		<script src="js/libs/acorn/acorn_loose.js"></script>
		<script src="js/libs/acorn/walk.js"></script>
		<script src="js/libs/ternjs/polyfill.js"></script>
		<script src="js/libs/ternjs/signal.js"></script>
		<script src="js/libs/ternjs/tern.js"></script>
		<script src="js/libs/ternjs/def.js"></script>
		<script src="js/libs/ternjs/comment.js"></script>
		<script src="js/libs/ternjs/infer.js"></script>
		<script src="js/libs/ternjs/doc_comment.js"></script>
		<script src="js/libs/tern-threejs/threejs.js"></script>
		<script src="js/libs/signals.min.js"></script>

		<!-- Import maps polyfill -->
		<!-- Remove this when import maps will be widely supported -->
		<script async src="https://unpkg.com/es-module-shims@1.3.6/dist/es-module-shims.js"></script>

		<script type="importmap">
			{
				"imports": {
					"three": "../build/three.module.js"
				}
			}
		</script>

		<script type="module">

			import * as THREE from 'three';

			import { checkFile, appGlobals, readFile, fetchModel, updateFromOrient, updateRotation, updateFromSimulation } from './js/Globals.js';
			import { initialPosition, Editor } from './js/Editor.js';
			import { Viewport } from './js/Viewport.js';
			import { Toolbar } from './js/Toolbar.js';
			import { Script } from './js/Script.js';
			import { Player } from './js/Player.js';
			import { Sidebar } from './js/Sidebar.js';
			import { Menubar } from './js/Menubar.js';
			import { Resizer } from './js/Resizer.js';
			import { VRButton } from '../examples/jsm/webxr/VRButton.js';

			window.URL = window.URL || window.webkitURL;
			window.BlobBuilder = window.BlobBuilder || window.WebKitBlobBuilder || window.MozBlobBuilder;

			Number.prototype.format = function () {

				return this.toString().replace( /(\d)(?=(\d{3})+(?!\d))/g, '$1,' );

			};

			//

			const editor = new Editor();
			editor.clear();

			window.globals = appGlobals; // application globals - by AG
			window.updateRotation = updateRotation; // useful for debugging - by AG
			window.editor = editor; // Expose editor to Console
			window.THREE = THREE; // Expose THREE to APP Scripts and Console
			window.VRButton = VRButton; // Expose VRButton to APP Scripts

			const viewport = new Viewport( editor );
			window.viewport = viewport; // Expose viewport to Console
			document.body.appendChild( viewport.dom );

			const toolbar = new Toolbar( editor );
			document.body.appendChild( toolbar.dom );

			const script = new Script( editor );
			document.body.appendChild( script.dom );

			const player = new Player( editor );
			document.body.appendChild( player.dom );

			const sidebar = new Sidebar( editor );
			document.body.appendChild( sidebar.dom );

			const menubar = new Menubar( editor );
			document.body.appendChild( menubar.dom );

			const resizer = new Resizer( editor );
			document.body.appendChild( resizer.dom );

			//

			editor.storage.init( function () {

				editor.storage.get( function ( state ) {

					if ( isLoadingFromHash ) return;

					if ( state !== undefined ) {

						editor.fromJSON( state );

					}

					const selected = editor.config.getKey( 'selected' );

					if ( selected !== undefined ) {

						editor.selectByUuid( selected );

					}

				} );

				//

				let timeout;

				function saveState() {

					if ( editor.config.getKey( 'autosave' ) === false ) {

						return;

					}

					clearTimeout( timeout );

					timeout = setTimeout( function () {

						editor.signals.savingStarted.dispatch();

						timeout = setTimeout( function () {

							editor.storage.set( editor.toJSON() );

							editor.signals.savingFinished.dispatch();

						}, 100 );

					}, 1000 );

				}

				const signals = editor.signals;

				signals.geometryChanged.add( saveState );
				signals.objectAdded.add( saveState );
				signals.objectChanged.add( saveState );
				signals.objectRemoved.add( saveState );
				signals.materialChanged.add( saveState );
				signals.sceneBackgroundChanged.add( saveState );
				signals.sceneEnvironmentChanged.add( saveState );
				signals.sceneFogChanged.add( saveState );
				signals.sceneGraphChanged.add( saveState );
				signals.scriptChanged.add( saveState );
				signals.historyChanged.add( saveState );

			} );

			//

			document.addEventListener( 'dragover', function ( event ) {

				event.preventDefault();
				event.dataTransfer.dropEffect = 'copy';

			} );

			document.addEventListener( 'drop', function ( event ) {

				event.preventDefault();

				if ( event.dataTransfer.types[ 0 ] === 'text/plain' ) return; // Outliner drop

				if ( event.dataTransfer.items ) {

					// DataTransferItemList supports folders

					editor.loader.loadItemList( event.dataTransfer.items );

				} else {

					editor.loader.loadFiles( event.dataTransfer.files );

				}

			} );

			function onWindowResize() {

				editor.signals.windowResize.dispatch();

			}

			window.addEventListener( 'resize', onWindowResize );

			onWindowResize();

			//

			let isLoadingFromHash = false;
			const hash = window.location.hash;

			if ( hash.slice( 1, 6 ) === 'file=' ) {

				const file = hash.slice( 6 );

				if ( confirm( 'Any unsaved data will be lost. Are you sure?' ) ) {

					const loader = new THREE.FileLoader();
					loader.crossOrigin = '';
					loader.load( file, function ( text ) {

						editor.clear();
						editor.fromJSON( JSON.parse( text ) );

					} );

					isLoadingFromHash = true;

				}

			}

			// ServiceWorker

			if ( 'serviceWorker' in navigator ) {

				try {

					navigator.serviceWorker.register( 'sw.js' );

				} catch ( error ) {

				}

			}

			// Custom ProMED app behavior - by AG

			// Parameters
			editor.config.setKey('data-model/parameters', undefined);
			editor.config.setKey('scene/modelRef', undefined);
			editor.config.setKey('process/model', undefined);
			editor.config.setKey('process/modelName', undefined);
			editor.config.setKey('process/parameters', undefined);
			editor.config.setKey('process/orient', undefined);
			editor.config.setKey('process/simulation', undefined);
			editor.config.setKey('process/existingModel', undefined);
			editor.config.setKey('process/inputFields', undefined);
			editor.config.setKey('process/orientedModel', undefined);
			editor.config.setKey('process/completed', undefined);
			editor.config.setKey('process/ml', undefined);			
			
			// Load data model parameters
			readFile('/home/volumes/shared/data-model/data-model.json', (response) => {
				console.log('Data model loaded');
				editor.config.setKey('data-model/parameters', JSON.parse(response).machine_model);
			})

			// Main directional lights
			var dl1 = new THREE.DirectionalLight(0xffffff, 1);
			dl1.position.set(100, 100, 200);
			editor.scene.add(dl1);

			var dl2 = new THREE.DirectionalLight(0xffffff, 0.5);
			dl2.position.set(-100, -100, -200);
			editor.scene.add(dl2);

			// Working area volume
			var blob = null;
			var xhr = new XMLHttpRequest();
			xhr.open("GET", '../files/working_area.stl');
			xhr.responseType = "blob";
			xhr.onload = function() {
			  blob = xhr.response;
				let file = new File([blob], "working area.stl");
				editor.loader.loadFile(file);
			}
			xhr.send();

			// stupid hack for waiting until model is loaded - by AG
			let areaInterval = setInterval(()=>{
				if (editor.scene.children.length > 2) {
					const material = editor.scene.children[2].material;
					material.transparent = true;
					material.opacity = 0.35;
					material.needsUpdate = true;
					material.side = 1;
					editor.deselect();
					clearInterval(areaInterval);

					/*
					//Materiale per working area helpers.stl -TIZIANO
					const material = editor.scene.children[2].material;
					material.transparent = true;
					material.opacity = 0.35;
					material.needsUpdate = true;
					material.side = 1;
					editor.deselect();
					clearInterval(interval);
					*/

					// Set values from query string
					if (window.location.search.split('?').length > 1) {
					  var params = window.location.search.split('?')[1].split('&');
					  for (var i = 0; i < params.length; i++) {
					    var key = params[i].split('=')[0];
					    var value = decodeURIComponent(params[i].split('=')[1]);
							editor.config.setKey('process/' + key, value);
					  }
					}

					// Upload model if present in query strings
					if (editor.config.getKey('process/model') != undefined) {
						fetchModel('/home/volumes/upload/models/' + editor.config.getKey('process/model'), (response) => {
							var blob = null;
							var xhr = new XMLHttpRequest();
							xhr.open("GET", '../' + response);
							xhr.responseType = "blob";
							xhr.onload = function() {
								console.log('Model loaded');
								blob = xhr.response;
								let file = new File([blob], editor.config.getKey('process/model'));
								editor.loader.loadFile(file);

								// Yet another very stupid hack for waiting until other model is loaded - by AG
								let modelInterval = setInterval(()=>{
									if (editor.scene.children.length > 3) {
										appGlobals.model = editor.scene.children[3]; // Useful?? - by AG
										appGlobals.model.material.needsUpdate = true;
										editor.config.setKey('process/existingModel', true);
										editor.deselect();
										clearInterval(modelInterval);

										// Upload parameters if present in query strings - by AG
										if (editor.config.getKey('process/parameters') != undefined) {
											readFile('/home/volumes/upload/parameters/' + editor.config.getKey('process/parameters'), (response) => {
												console.log('Parameters loaded');
          					  	let parameters = JSON.parse(response);

												document.querySelector('#directions input').value = parameters.input_fields.directions;
        								document.querySelector('#angle input').value = parameters.input_fields.angle;
        								document.querySelector('#buffer input').value = parameters.input_fields.buffer;
        								document.querySelector('#height input').value = parameters.input_fields.height;
        								document.querySelector('#shadow input').value = parameters.input_fields.shadow;
        								document.querySelector('#contact input').value = parameters.input_fields.contact;
        								document.querySelector('#volume input').value = parameters.input_fields.volume;
        								document.querySelector('#critical input').value = parameters.input_fields.critical;
        								document.querySelector('#cone input').value = parameters.input_fields.cone;
        								document.querySelector('#angle input').value = parameters.input_fields.angle;
        								document.querySelector('#layer input').value = parameters.input_fields.layer;
        								document.querySelector('#density input').value = parameters.input_fields.density;
												document.querySelector('#forbidden textarea').value = parameters.input_fields.forbidden;

												// Update scene according to output files if present - by AG
												readFile('/home/volumes/log/log.json', (response) => {
													let log = JSON.parse(response);
													let orientOutput = log.operations.orients
														.find(value => { return value.parameters === editor.config.getKey('process/parameters'); });
													if (orientOutput !== undefined) {
														readFile(
															'/home/volumes/orient-output/' + orientOutput.name,
															(results) => {
																console.log('Orient results loaded');
																updateFromOrient(JSON.parse(results));
																editor.signals.rendererUpdated.dispatch();

																// Set reference to oriented model
																let orientedPath = '/home/volumes/upload/models/oriented/';
            										let orientedName =
            										  editor.config.getKey('process/modelName').split('.')[0] +
																	'_oriented_' +
																	editor.config.getKey('process/parameters').split('.')[0] +
																	'.stl';
																editor.config.setKey('process/orientedModel', orientedPath + orientedName);

																// Upload oriented model in shared volume if not already present
																checkFile(editor.config.getKey('process/orientedModel'), (response) => {
																	console.log(editor.config.getKey('process/orientedModel'));
																	console.log(response);
																	if (response == 'File does not exist') {
																		// upload
																		var upload_request = new XMLHttpRequest();
	            											upload_request.open('POST', '../../scripts/upload_oriented.php');
	            											upload_request.onreadystatechange = function() {
																			console.log(upload_request.response);
              											  editor.config.setKey('process/orientedModel', upload_request.response);
              											}
              											let uploadForm = new FormData();
              											uploadForm.append('model', editor.config.getKey('process/model'))
              											uploadForm.append('filename', orientedName);
              											upload_request.send(uploadForm);
																		console.log('uploaded');
																	} else {
																		console.log('already uploaded');
																	}
																});
															}
														);
													}
													let simulationOutput = log.operations.simulations
														.find(value => { return value.parameters === editor.config.getKey('process/parameters');});
													if (simulationOutput !== undefined) {
														readFile(
															'/home/volumes/simulation-output/' + simulationOutput.name,
															(results) => {
																console.log('Simulation results loaded');
																updateFromSimulation(results);
															}
														);
													}
													document.getElementById('results').setAttribute('style', 'display: block');
													document.getElementById('results__values').setAttribute('style', 'display: block');
												});
											});
										}
									}
								}, 100);
							};
							xhr.send();
						});
					}
				} else {
					//console.log("Working area not loaded yet");
				}
			}, 150);

		</script>
	</body>
</html>
